'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.create = exports.meta = undefined;

var _slicedToArray = function () { function sliceIterator(arr, i) { var _arr = []; var _n = true; var _d = false; var _e = undefined; try { for (var _i = arr[Symbol.iterator](), _s; !(_n = (_s = _i.next()).done); _n = true) { _arr.push(_s.value); if (i && _arr.length === i) break; } } catch (err) { _d = true; _e = err; } finally { try { if (!_n && _i["return"]) _i["return"](); } finally { if (_d) throw _e; } } return _arr; } return function (arr, i) { if (Array.isArray(arr)) { return arr; } else if (Symbol.iterator in Object(arr)) { return sliceIterator(arr, i); } else { throw new TypeError("Invalid attempt to destructure non-iterable instance"); } }; }();

var _moduleVisitor = require('eslint-module-utils/moduleVisitor');

var _moduleVisitor2 = _interopRequireDefault(_moduleVisitor);

var _parsePackageName = require('parse-package-name');

var _parsePackageName2 = _interopRequireDefault(_parsePackageName);

var _getPackages = require('../get-packages');

var _getPackages2 = _interopRequireDefault(_getPackages);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _objectWithoutProperties(obj, keys) { var target = {}; for (var i in obj) { if (keys.indexOf(i) >= 0) continue; if (!Object.prototype.hasOwnProperty.call(obj, i)) continue; target[i] = obj[i]; } return target; }

var meta = exports.meta = {
  schema: [(0, _moduleVisitor.makeOptionsSchema)({
    rootDir: {
      type: 'string',
      required: true
    }
  })]
};

var create = function create(context) {
  var _context$options = _slicedToArray(context.options, 1),
      _context$options$ = _context$options[0],
      rootDir = _context$options$.rootDir,
      moduleUtilOptions = _objectWithoutProperties(_context$options$, ['rootDir']);

  var packages = (0, _getPackages2.default)(rootDir);

  return (0, _moduleVisitor2.default)(function (node) {
    var _parse = (0, _parsePackageName2.default)(node.value),
        name = _parse.name,
        internalPath = _parse.path;

    if (internalPath && packages.find(function (pkg) {
      return pkg.name === name;
    })) {
      context.report({
        node: node,
        message: 'Import for monorepo package \'' + name + '\' is internal.'
      });
    }
  }, moduleUtilOptions);
};
exports.create = create;